/*******************************************************************************
 *  This is the ball class, which inherits from the RectThing class.  It does
 *  ball-specific things, mostly relating to direction, velocity and movement.
 ******************************************************************************/
#ifndef CLASS_BALL_H
#define CLASS_BALL_H

/*
 *  The Ball class
 */
class Ball : public RectThing
{
    public:
        /*  Constructor */
        Ball( void );

        /*  Move the ball */
        void move( void );

        /*  Move back */
        void reset_position( void );

        /*  Check for collision */
        bool collision( SDL_Rect paddle );

        /*  Set the directions */
        void set_dx( int dX );
        void set_dy( int dY );

        /*  Get the directions */
        int get_dx( void );
        int get_dy( void );

        /*  Flip the directions */
        void flip_dx( void );
        void flip_dy( void );

        /*  Handle the ball getting hit */
        void hit( void );

        /*  Bounce angle stuff */
        void set_max_bounce_angle( int angle );
        int get_max_bounce_angle( void );

        /*  Update */
        void update( void );

    private:
        /*  The directions */
        int dx, dy;

        /*  Number of times the ball has been hit */
        int mHits;

        /*  Max bounce angle */
        int mMaxBounceAngle;

        /*  Default speed */
        int mVelocityDefault;
};

#endif
