/*******************************************************************************
 *                              !!!!
 *
 *  This file deals with all of the laying out of various... everything.  It
 *  exists to accomodate the resizing of the window (including fullscreen mode),
 *  though this has not yet been implemented.  It may never be.
 *
 *                              !!!!
 ******************************************************************************/
#ifndef UTIL_H
#include "util.h"
#endif


void layout_ball( void )
{
    if( fullscreen )
    {
        ball->set_width( sHeight / 30 );
        ball->set_height( sHeight / 30 );
    }
    else
    {
        ball->set_width( 20 );
        ball->set_height( 20 );
    }

    ball->init_collider();
}


void layout_paddles( void )
{
    if( fullscreen )
    {
        for( int i = 0; i < 2; ++i )
        {
            paddles[ i ]->set_width( sWidth / 60 );
            paddles[ i ]->set_height( sHeight / 8 );
        }
    }

    else
    {
        for( int i = 0; i < 2; ++i )
        {
            paddles[ i ]->set_width( 20 );
            paddles[ i ]->set_height( 100 );
        }
    }


    /*
    paddles[ 0 ]->set_position(
            paddles[ 0 ]->get_width() + 10,
            ( sHeight - paddles[ 0 ]->get_height() ) / 2 );

    paddles[ 1 ]->set_position(
            sWidth - (paddles[ 1 ]->get_width() + 10),
            ( sHeight - paddles[ 1 ]->get_height() ) / 2 );
            */

    paddles[ 0 ]->init_collider();
    paddles[ 1 ]->init_collider();


}

void layout_midline( void )
{
    midRect.w = sWidth / 200;
    midRect.h = sHeight / 40;

    midRect.x = ( sWidth - midRect.w ) / 2;
    midRect.y = 0;
}


void layout_help_text( void )
{

    gHelpScreen[ T_HELP_KEYBOARD ]->set_position(
            sWidth/5,
            sHeight/20 );
    for( int i = 1; i < T_HELP_TOTAL; ++i )
    {
        gHelpScreen[ i ]->set_position(
                sWidth/3.5,
                ( gHelpScreen[ i ]->get_height() * i ) +
            sHeight/20 );
    }

    gHelpScreenGamepad[ T_HELP_GAMEPAD ]->set_position(
            sWidth/5,
            sHeight/2 );
    for( int i = 1; i < T_HELP_TOTAL_G; ++i )
    {
        gHelpScreenGamepad[ i ]->set_position(
                sWidth/3.5,
                ( gHelpScreenGamepad[ i ]->get_height() * i ) +
                sHeight/2 );
    }
}


void layout_textures( void )
{
    printf("NULL\n");
}


void layout_scores( void )
{
    gScores[ 0 ]->set_position(
            ( ( sWidth / 2 ) - gScores[ 0 ]->get_width() ) / 2,
            ( gScores[ 0 ]->get_height() ) );

    gScores[ 1 ]->set_position(
            (sWidth - sWidth/2) + (( (sWidth/2) - gScores[1]->get_width() )/2),
            ( gScores[ 1 ]->get_height() ) );
}


void layout_main( void )
{
    layout_ball();
    layout_paddles();
    layout_midline();
    layout_help_text();
    layout_scores();
    //layout_textures();
}
