/*******************************************************************************
 *  This file handles all of the rendering.
 ******************************************************************************/
#ifndef UTIL_H
#include "util.h"
#endif


/*
--------------------------------------------------------------------------------
                                  RENDER_MAIN
--------------------------------------------------------------------------------
*/
void render_main( void )
{
    /*  Set the render draw color to the background color */
    SDL_SetRenderDrawColor( gRenderer,
            bgColor.r, bgColor.g, bgColor.b, 0xff );

    /*  Draw the background */
    SDL_RenderClear( gRenderer );


    /*  If we're on the main screen */
    if( currentScreen == SCREEN_MAIN )
    {
        /*  Render paddles */
        paddles[ 0 ]->render();
        paddles[ 1 ]->render();

        /*  Render ball */
        ball->render();

        /*  Render the scores */
        if( showScores )
        {
            gScores[ 0 ]->render();
            gScores[ 1 ]->render();
        }

        /*  Render the middle line */
        if( midline )
            render_midline();

        /*  Render the OSD */
        if( showOSD )
            osd.render();
    }


    /*  If we're on the help screen */
    else if( currentScreen == SCREEN_HELP )
    {
        for( int i = 0; i < T_HELP_TOTAL; ++i )
        {
            gHelpScreen[ i ]->render();
            gHelpScreenGamepad[ i ]->render();
        }
    }


    /*  If we're on the game over screen */
    else if( currentScreen == SCREEN_GAME_OVER )
    {
        for( int i = 0; i < T_GAME_OVER_TOTAL; ++i )
        {
            gGameOverTextures[ i ]->render();
        }
    }

    /*  Update the screen */
    SDL_RenderPresent( gRenderer );

    /*  Basic FPS delay */
    SDL_Delay( 1000 / DEFAULT_FPS );

}
